#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <bios.h>
#include <time.h>
#include <math.h>

/*** Die Adresse der Druckersschnittstelle kann verschieden sein.
**** Laptop:  03BC (Daten) 03BD (Status) 03BE (Steuer)
**** Mein PC: 0378 (Daten) 079D (Status) 037A (Steuer)
***/
#define Par_Sst 0x3BC
#define lpt1_stat 0x3BD  /* Adresse des Statusregisters*/
								 /* der Parallel-Schnittstelle */
/* Hardware-Konstanten */
#define Torzeit 0x80  /* Bit 7 des Statusregisters  */
#define ImpulsDruck  0x10  /* Bit 5  "        "          */
#define ImpulsTemp  0x20  /* Bit 5  "        "          */

#define n 1

#define ESC 0x11b
#define RETURN 0x1c0d
#define TABULATOR 0xf09

#define F1 0x3b00
#define F2 0x3c00
#define F3 0x3d00
#define F4 0x3e00
#define F5 0x3f00
#define F6 0x4000
#define F7 0x4100
#define F8 0x4200
#define F9 0x4300
#define F10 0x4400

#define ALT_F1 0x6800
#define ALT_F2 0x6900
#define ALT_F3 0x6a00
#define ALT_F4 0x6b00
#define ALT_F5 0x6c00
#define ALT_F6 0x6d00
#define ALT_F7 0x6e00
#define ALT_F8 0x6f00
#define ALT_F9 0x7000
#define ALT_F10 0x7100

#define SHIFT_F1 0x5400
#define SHIFT_F2 0x5500
#define SHIFT_F3 0x5600
#define SHIFT_F4 0x5700
#define SHIFT_F5 0x5800
#define SHIFT_F6 0x5900
#define SHIFT_F7 0x6000
#define SHIFT_F8 0x6100
#define SHIFT_F9 0x6200
#define SHIFT_F10 0x6300

#define AN 1
#define AUS 0

#define HEIZUNG 16
#define WASSER 2
#define MOTOR_L 4
#define MOTOR_R 8
#define PUMPEN 1
#define SPUELEN 32
#define CHECKEN 64

#define LAENGE 111
#define SAETZE 50

char datenbyte = 0;
char Drehrichtung = 'L';

double Referenz;

void schalten(int relais, char Schalter);
int Motor( char Schalter );
int erg_taste(int Taste);
int Unterbrechung();
double tempmessneu();
int tempmessneu2();
long referenz();
void main()
{
int i, j, Nummer, Taste;
double ZaehlerDruck;
double Z1,Z2,Z3,Z4,Z5,ZaehlerTempneu = 0.00;
Referenz = 0.00;
outportb(Par_Sst,0);
				printf("Checkbit ist an\n");
				schalten(CHECKEN, AN);
Referenz = (referenz() / 45260244.0);

clrscr();
	gotoxy (1,25);
	cprintf("F1:Heizung|F2:Wasser|F3:Motor|F4:Pumpe|F5:Splen|Fx: AN|ALT-Fx:AUS|ESC=ABBRUCH");

for(i=0; 1;)
	{
/*		for (j=0;j<5;j++)
		{
			switch(j)
			{
			  case 0: Z1 = tempmessneu(); break;
			  case 1: Z2 = tempmessneu(); break;
			  case 2: Z3 = tempmessneu(); break;
			  case 3: Z4 = tempmessneu(); break;
			  case 4: Z5 = tempmessneu(); break;
			}
		}
		ZaehlerTempneu = ((Z1+Z2+Z3+Z4+Z5)/5);
		gotoxy(5,10);
		cprintf("ZaehlerNeu: %.2f  ",ZaehlerTempneu); */
		tempmessneu2();
		ZaehlerDruck = druckmess();
		gotoxy(5,13);
		cprintf("Druck: %.2f  ", ZaehlerDruck);
		Taste = Unterbrechung();
		if (Taste != 0) if(erg_taste(Taste)==1)
			{
				outportb(Par_Sst,0);
				return;
			}
	}
}
/********************************************************/
/* Unterprogramm zur Temperaturmessung                x  */
/********************************************************/

double tempmessneu()
{
int Zaehler,i;
long Summe = 0, Ergebnis=0.00;
double Endergebnis = 0.00;
for (i=0;i<1000;i++)
	{
		M0:
			asm{
				mov Zaehler,0
				mov dx,lpt1_stat
			 }
		M1:
			asm{
				  in al,dx
				  test al,ImpulsTemp
				  jnz M1
				 }
		 M2:
			 asm{
				  in al,dx
				  test al,ImpulsTemp
				  jz M2
				 }
		 M3:
			 asm{
					in al,dx
					test al,ImpulsTemp
					jz M5
					inc Zaehler
					jmp M3
				 }
		 M5:  Summe = Zaehler + Ergebnis;
				Ergebnis = Summe;
	}
 Ergebnis = (Summe / Referenz);
 if (Ergebnis<50000)
	Endergebnis = (((Ergebnis/100)-436.6) * (30.0/44.0));
 else
	Endergebnis = (((Ergebnis/100)-436.6) * (30.0/44.0));
 gotoxy(5,11);
 cprintf("Zaehler: %li  ",Ergebnis);

/* Endergebnis = (Ergebnis /100); */
 return(Endergebnis);
}

/********************************************************/
/* Unterprogramm zur Temperaturmessung                  */
/********************************************************/

int tempmessneu2()
{
int ZaehlerA,ZaehlerB,i;
float SummeA = 0, ErgebnisA=0.00;
float SummeB = 0, ErgebnisB=0.00;
double Endergebnis = 0.00;
  for(i=0;i<1000;i++)
  {
		M0:
			asm{
				mov ZaehlerA,0
				mov ZaehlerB,0
				mov dx,lpt1_stat
			 }
		M1:
			asm{
				  in al,dx
				  test al,ImpulsTemp
				  jnz M1
				 }
		 M2:
			 asm{
				  in al,dx
				  test al,ImpulsTemp
				  jz M2
				 }
		 M3:
			 asm{
					in al,dx
					test al,ImpulsTemp
					jz M4
					inc ZaehlerA
					jmp M3
				 }
		 M4:
		 asm{
					in al,dx
					test al,ImpulsTemp
					jnz M5
					inc ZaehlerB
					jmp M4
				}
		 M5: SummeA = ErgebnisA + ZaehlerA;
			  ErgebnisA = SummeA;
			  SummeB = ErgebnisB + ZaehlerB;
			  ErgebnisB = SummeB;

	 }
		 gotoxy(5,20);
		 cprintf("ZaehlerImp: %.2f  ",ErgebnisA);
		 gotoxy(5,21);
		 cprintf("ZaehlerAus: %.2f  ",ErgebnisB);
		 gotoxy(5,22);
		 Endergebnis = ((ErgebnisA/ErgebnisB) * 100.00);
		 cprintf("Zahl: %.4f  ",Endergebnis);
		 gotoxy(5,23);
/*		 Endergebnis = ( (((ErgebnisA/ErgebnisB) * 100)-7.7)*(85.00/315.60)); */
		 SummeA = (ErgebnisA/ErgebnisB)*100;
		 Endergebnis = (pow((SummeA-48.5),0.45)*7.5);
		 cprintf("Ergebnis: %.4f  ",Endergebnis);
		 gotoxy(5,24);
		 Endergebnis = pow(3,2);
		 cprintf ("Test: %.4f   ", Endergebnis);

		return(Endergebnis);
}

/********************************************************/
/* Unterprogramm zur Ermittlung der Rechnergeschwindigkeit */
/********************************************************/

long referenz()
{
long Zaehler;
 asm{
		mov Zaehler,0
		mov dx,lpt1_stat
	 }
 M1:
 asm{
		in al,dx
		test al,Torzeit
		jnz M1
	 }
 M2:
 asm{
		in al,dx
		test al,Torzeit
		jz M2
	 }
 M3:
 asm{
		in al,dx
		test al,Torzeit
		jz M5
		inc Zaehler
		jmp M3
    }
 M5:	return(Zaehler);
}

/***************************************************************************
**** Prft, ob Taste gedrckt wurde
***************************************************************************/

int Unterbrechung()
{
	if( bioskey( 1 ) != 0 )
	{
		return( bioskey( 0 ));
	}
	else
		return 0;
}

/***************************************************************************
**** Prft, welche Taste gedrckt wurde
***************************************************************************/

int erg_taste(int Taste)
{
	gotoxy(30,15);
	switch(Taste)
		{
			case ESC: return(1);
			case F1: cprintf("Heizung ist an				 ");
						schalten(HEIZUNG, AN);
						break;
			case F2: cprintf("Wasser ist an		     ");
						schalten(WASSER, AN);
						break;
			case F3: cprintf("Motor ist an				");
						if (Motor( AN )==1) cprintf("Motorfehler");
						break;
			case F4: schalten(PUMPEN, AN);
						cprintf("Pumpe ist an				");
						break;
			case F5: schalten(SPUELEN, AN);
						cprintf("Splen ist an				");
						break;
			case ALT_F1: 	cprintf("Heizung ist aus				");
								schalten(HEIZUNG, AUS);
								break;
			case ALT_F2: 	cprintf("Wasser ist aus					");
								schalten(WASSER, AUS);
								break;
			case ALT_F3:   cprintf("Motor ist aus					");
								if (Motor( AUS )==1) cprintf("Motorfehler");
								break;
			case ALT_F4:   cprintf("Pumpen ist aus					");
								schalten(PUMPEN, AUS);
								break;
			case ALT_F5:   cprintf("Splen ist aus					");
								schalten(SPUELEN, AUS);
								break;
		}
	return 0;
}


/***************************************************************************
**** Schaltet Relais ein und aus
***************************************************************************/

void schalten(int relais, char Schalter)
{
	if (Schalter == AUS)
		{
		if ((datenbyte & relais) == relais)
			datenbyte = datenbyte ^ relais;
		}
	else
		datenbyte = datenbyte | relais;

	outportb(Par_Sst,datenbyte);
	delay(1000);
}
/***************************************************************************
**** Prft, ob Motor bereits luft, und schaltet im Wechsel zwischen Links-
**** und Rechtslauf den Motor an oder aus. Bei bereits gesetztem Motor-Bit
**** wird das Programm abgebrochen.
***************************************************************************/

int Motor( char Schalter )
{
	int Relais;

	if( Schalter == AN )
	{
		if (( (datenbyte & MOTOR_R) == 0 ) && ( (datenbyte & MOTOR_L)  == 0 ))
		{
			if( Drehrichtung == 'L' )
			{
				Drehrichtung = 'R';
				Relais = MOTOR_R;
			}
			else
			{
				Drehrichtung = 'L';
				Relais = MOTOR_L;
			}
			schalten( Relais, AN );
		}
		else
			{
				printf( "Motor luft bereits !!! PROGRAMMABBRUCH\n" );
				return 1;
			}
	}
	else
	{
		if( Drehrichtung == 'L' )
		{
			Relais = MOTOR_L;
		}
		else
		{
			Relais = MOTOR_R;
		}
		schalten( Relais, AUS );
	}
	return 0;
}
/********************************************************/
/* Unterprogramm zur Druckmessung                       */
/********************************************************/

int druckmess()
{
 int Flag;
 int Zaehler;
 asm{
		mov Zaehler,0	/*   Initialisierung    */
		mov Flag,0
                mov dx,lpt1_stat
    }
 M1:
 asm{
		in  al,dx
		test al,Torzeit
		jnz M1
    }
 M2:
 asm{
		in al,dx
		test al,Torzeit
		jz M2
    }
 M3:
 asm{
		in al,dx
		test al,Torzeit
		jz M5
		test al,ImpulsDruck
		jnz M4
		mov Flag,0
		jmp M3
    }
 M4:
 asm{
		cmp Flag,1
		je M3
		inc Zaehler
		mov Flag,1
		jmp M3
    }
 M5:            asm mov ax,Zaehler /* Rckgabe der */
                     /* Drehzahl ans Hauptprogramm */
		/* asm ret; */
	return(Zaehler);
}
