/*************************************************************************
***** Programm: BIER.EXE
***** Hauptprogramm: DRU_TEM.C
***** TABELLE.C verwaltet die Datenbank zum Bierbrauen.
*****
***** Datei: DATEN.DAT
*****
***** Unterprogramme: KREIS.C, ABLAUF.C, TABELLE2.C
*****
***** Autor: Markus Fey
***** Erstellt am: 26.12.1996
***** Update: 5.1.1997
****************************************************************************/

#include <stdio.h>

/*---------------*/
/* Definitionen  */
/*---------------*/
#define LAENGE 111
#define SAETZE 50

FILE *pDatei;
struct {
	  char name[20+1];
	  int liter;
	  int malz;
	  int hopfen;
	  int eiw_temperatur;
	  int eiw_gesamtzeit;
	  int eiw_motorzeit;
	  int eiw_motorintervall;
	  int malt_temperatur;
	  int malt_gesamtzeit;
	  int malt_motorzeit;
	  int malt_motorintervall;
	  int zucker_temperatur;
	  int zucker_gesamtzeit;
	  int zucker_motorzeit;
	  int zucker_motorintervall;
	  int koch_zeit;
	  int koch_temperatur;
     int koch_unterbrechung;
	}
	zeile[SAETZE];

/*------------*/
/* Prototypen */
/*------------*/
void InitZeile(int Nummer);
void SchreibZeile( int Nummer );
void LiesZeile( int Nummer );
void FuellZeile( int Nummer );
void KorrZeile( int Nummer );
int pflege_datei();
int hol_satz( int zaehlsatz );

int pflege_datei (void)
{
	int i, Nummer=0;
	char buffer [LAENGE+1];

	clrscr();

	if((pDatei=fopen("DATEN.DAT","r+"))==NULL)
	{
		pDatei=fopen("DATEN.DAT","w");
		for(i=0; i<=SAETZE; i++)
		{
			InitZeile( i );
			SchreibZeile( i );
		}
		fclose(pDatei);
		pDatei=fopen("DATEN.DAT","r+");
	}

	for( i=0; i<=SAETZE; i++ )
	{
		InitZeile( i );
	}

	for( i=0; i<SAETZE; i++ )
	{
		LiesZeile( i );
	}

	clrscr();

	for( i=0; i<10; i++ )
	{
		printf( "\n Bitte Satznummer eingeben (Verlassen mit 999): " );
		scanf( "%d", &Nummer );
		if( Nummer == 999 )
			break;
		if( Nummer > SAETZE )
		{
			printf( "Zu hohe Satznummer !!!\n" );
			continue;
		}
		if( zeile[Nummer].name[0] == '.' )
		{
			printf( "\n-- NEUANLAGE --\n" );
			FuellZeile( Nummer );
		}
		else
		{
			printf( "\n-- ANZEIGE --\n" );
			printf( "%-20s %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d\n",
												zeile[Nummer].name,
												zeile[Nummer].liter,
												zeile[Nummer].malz ,
												zeile[Nummer].hopfen ,
												zeile[Nummer].eiw_temperatur ,
												zeile[Nummer].eiw_gesamtzeit ,
												zeile[Nummer].eiw_motorzeit ,
												zeile[Nummer].eiw_motorintervall ,
												zeile[Nummer].malt_temperatur ,
												zeile[Nummer].malt_gesamtzeit ,
												zeile[Nummer].malt_motorzeit ,
												zeile[Nummer].malt_motorintervall ,
												zeile[Nummer].zucker_temperatur ,
												zeile[Nummer].zucker_gesamtzeit ,
												zeile[Nummer].zucker_motorzeit ,
												zeile[Nummer].zucker_motorintervall ,
												zeile[Nummer].koch_zeit ,
												zeile[Nummer].koch_temperatur ,
												zeile[Nummer].koch_unterbrechung

			);
			KorrZeile( Nummer );
		}
	}

	fclose(pDatei);
	return 0;
}

void InitZeile( int Nummer )
{
		zeile[Nummer].name[0] = '.';
		zeile[Nummer].name[1] = '\0';
		zeile[Nummer].liter = 0;
		zeile[Nummer].malz = 0;
		zeile[Nummer].hopfen = 0;
		zeile[Nummer].eiw_temperatur = 0;
		zeile[Nummer].eiw_gesamtzeit = 0;
		zeile[Nummer].eiw_motorzeit = 0;
		zeile[Nummer].eiw_motorintervall = 0;
		zeile[Nummer].malt_temperatur = 0;
		zeile[Nummer].malt_gesamtzeit = 0;
		zeile[Nummer].malt_motorzeit = 0;
		zeile[Nummer].malt_motorintervall = 0;
		zeile[Nummer].zucker_temperatur = 0;
		zeile[Nummer].zucker_gesamtzeit = 0;
		zeile[Nummer].zucker_motorzeit = 0;
		zeile[Nummer].zucker_motorintervall = 0;
		zeile[Nummer].koch_zeit = 0;
		zeile[Nummer].koch_temperatur = 0;
		zeile[Nummer].koch_unterbrechung = 0;
}

void SchreibZeile( int Nummer )
{
	char buffer[LAENGE+1];


	setmem( buffer, LAENGE+1, '\0' );

	sprintf( buffer, "%-20s %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d %04d\n",
												zeile[Nummer].name,
												zeile[Nummer].liter,
												zeile[Nummer].malz ,
												zeile[Nummer].hopfen ,
												zeile[Nummer].eiw_temperatur ,
												zeile[Nummer].eiw_gesamtzeit ,
												zeile[Nummer].eiw_motorzeit ,
												zeile[Nummer].eiw_motorintervall ,
												zeile[Nummer].malt_temperatur ,
												zeile[Nummer].malt_gesamtzeit ,
												zeile[Nummer].malt_motorzeit ,
												zeile[Nummer].malt_motorintervall ,
												zeile[Nummer].zucker_temperatur ,
												zeile[Nummer].zucker_gesamtzeit ,
												zeile[Nummer].zucker_motorzeit ,
												zeile[Nummer].zucker_motorintervall ,
												zeile[Nummer].koch_zeit ,
												zeile[Nummer].koch_temperatur ,
												zeile[Nummer].koch_unterbrechung

			);

	fwrite(buffer,strlen(buffer),1,pDatei);

}

void LiesZeile( int Nummer )
{

	fseek( pDatei, Nummer*LAENGE, SEEK_SET );

	fscanf( pDatei, "%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d", 	&zeile[Nummer].name,
												&zeile[Nummer].liter,
												&zeile[Nummer].malz ,
												&zeile[Nummer].hopfen ,
												&zeile[Nummer].eiw_temperatur ,
												&zeile[Nummer].eiw_gesamtzeit ,
												&zeile[Nummer].eiw_motorzeit ,
												&zeile[Nummer].eiw_motorintervall ,
												&zeile[Nummer].malt_temperatur ,
												&zeile[Nummer].malt_gesamtzeit ,
												&zeile[Nummer].malt_motorzeit ,
												&zeile[Nummer].malt_motorintervall ,
												&zeile[Nummer].zucker_temperatur ,
												&zeile[Nummer].zucker_gesamtzeit ,
												&zeile[Nummer].zucker_motorzeit ,
												&zeile[Nummer].zucker_motorintervall ,
												&zeile[Nummer].koch_zeit ,
												&zeile[Nummer].koch_temperatur ,
												&zeile[Nummer].koch_unterbrechung
			);

}

void FuellZeile( int Nummer )
{
	printf(" Name des Brauvorgangs (z.B.: ALTBIER: ");
	scanf("%s",&zeile[Nummer].name);

	printf(" Menge in Litern: " );
	scanf("%d",&zeile[Nummer].liter);

	printf(" Menge an Malz in Kilogramm pro 10 Litern: " );
	scanf("%d",&zeile[Nummer].malz);

	printf(" Hopfenmenge in Gramm pro 10 Liter : " );
	scanf("%d",&zeile[Nummer].hopfen);

	printf(" Temperatur der Eiweirast in Grad Celsius: " );
	scanf("%d",&zeile[Nummer].eiw_temperatur);

	printf(" Dauer der Eiweirast in Minuten: " );
	scanf("%d",&zeile[Nummer].eiw_gesamtzeit);

	printf(" Dauer der Trommeldrehungen in Sekunden (0=AN): " );
	scanf("%d",&zeile[Nummer].eiw_motorzeit);

	printf(" Abstand zwischen den Trommeldrehungen in Minuten (0=AUS): " );
	scanf("%d",&zeile[Nummer].eiw_motorintervall);

	printf("  Temperatur der Maltoserast in Grda Celsius: " );
	scanf("%d",&zeile[Nummer].malt_temperatur);

	printf(" Dauer der Maltoserast in Minuten: " );
	scanf("%d",&zeile[Nummer].malt_gesamtzeit);

	printf(" Dauer der Trommeldrehungen in Sekunden (O=AN): " );
	scanf("%d",&zeile[Nummer].malt_motorzeit);

	printf(" Abstand zwischen den Trommeldrehungen in Minuten(=AUS): " );
	scanf("%d",&zeile[Nummer].malt_motorintervall);

	printf(" Temperatur der Verzuckerungsphase in Grad Celsius: " );
	scanf("%d",&zeile[Nummer].zucker_temperatur);

	printf(" Dauer der Verzuckerungspahse in Minuten: " );
	scanf("%d",&zeile[Nummer].zucker_gesamtzeit);

	printf(" Dauer der Trommeldrehungen in Sekunden (O=AN): " );
	scanf("%d",&zeile[Nummer].zucker_motorzeit);

	printf("  Abstand zwischen den Trommeldrehungen in Minuten(=AUS): " );
	scanf("%d",&zeile[Nummer].zucker_motorintervall);

	printf(" Kochzeit: " );
	scanf("%d",&zeile[Nummer].koch_zeit);

	printf(" Koch_temperatur: " );
	scanf("%d",&zeile[Nummer].koch_temperatur);

	printf(" Kochunterbrechung mit Signal nach XX Minuten: ");
	scanf("%d",&zeile[Nummer].koch_unterbrechung);

	fseek(pDatei,Nummer*LAENGE,SEEK_SET);
	SchreibZeile( Nummer );

}

void KorrZeile( int Nummer )
{
	char buffer[100];

	printf( "\nZum Uebernehmen # eingeben \n" );

	printf( " Name des Brauvorgangs (z.B.: ALTBIER: %s] ", zeile[Nummer].name );
	scanf( "%s", &buffer );
	if( buffer[0] != '#' )
		strcpy( zeile[Nummer].name, buffer );

	printf( " Menge in Litern: %d] ", zeile[Nummer].liter );
	scanf( "%s", &buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].liter = atoi( buffer );

	printf(" Menge an Malz in Kilogramm pro 10 Litern: [%d]",zeile[Nummer].malz );
	scanf("%s", &buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].malz = atoi( buffer );

	printf(" Hopfenmenge in Gramm pro 10 Liter: [%d]",zeile[Nummer].hopfen );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].hopfen = atoi( buffer );

	printf(" Temperatur der Eiweirast in Grad Celsius: [%d]",zeile[Nummer].eiw_temperatur );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].eiw_temperatur = atoi( buffer );

	printf("  Eiw_gesamtzeit: [%d]",zeile[Nummer].eiw_gesamtzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].eiw_gesamtzeit = atoi( buffer );

	printf("  Eiw_motorzeit: [%d]",zeile[Nummer].eiw_motorzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].eiw_motorzeit = atoi( buffer );

	printf("  Eiw_motorintervall: [%d]",zeile[Nummer].eiw_motorintervall );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].eiw_motorintervall = atoi( buffer );

	printf("  Malt_temperatur: [%d]",zeile[Nummer].malt_temperatur );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].malt_temperatur = atoi( buffer );

	printf("  Malt_gesamtzeit: [%d]",zeile[Nummer].malt_gesamtzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].malt_gesamtzeit = atoi( buffer );

	printf("  Malt_motorzeit: [%d]",zeile[Nummer].malt_motorzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].malt_motorzeit = atoi( buffer );

	printf("  Malt_motorintervall: [%d]",zeile[Nummer].malt_motorintervall );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].malt_motorintervall = atoi( buffer );

	printf("  Zucker_temperatur: [%d]",zeile[Nummer].zucker_temperatur );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].zucker_temperatur = atoi( buffer );

	printf("  Zucker_gesamtzeit: [%d]",zeile[Nummer].zucker_gesamtzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].zucker_gesamtzeit = atoi( buffer );

	printf("  Zucker_motorzeit: [%d]",zeile[Nummer].zucker_motorzeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].zucker_motorzeit = atoi( buffer );

	printf("  Zucker_motorintervall: [%d]",zeile[Nummer].zucker_motorintervall );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].zucker_motorintervall = atoi( buffer );

	printf("  Koch_zeit: [%d]",zeile[Nummer].koch_zeit );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].koch_zeit = atoi( buffer );

	printf("  Koch_temperatur: [%d]",zeile[Nummer].koch_temperatur );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].koch_temperatur = atoi( buffer );

	printf("  Koch_unterbrechung [%d]",zeile[Nummer].koch_unterbrechung );
	scanf("%s",&buffer);
	if( buffer[0] != '#' )
		zeile[Nummer].koch_unterbrechung = atoi( buffer );


	fseek(pDatei,Nummer*LAENGE,SEEK_SET);
	SchreibZeile( Nummer );

}

int hol_satz( int zaehlsatz )
{
	int i;
	if((pDatei=fopen("DATEN.DAT","r+"))==NULL)
	{
		printf( "Fehler beim ffnen der Datei DATEN.DAT\n" );
		return 999;
	}

	for( i=0; i<=SAETZE; i++ )
	{
		InitZeile( i );
	}

	for( i=0; i<SAETZE; i++ )
	{
		LiesZeile( i );
	}

	fclose( pDatei );
	return zaehlsatz;

}